import static org.junit.Assert.*;
import org.junit.*;

public class FingerExercisesTests {

  /**
   * All of these test cases are provided for you to help test your code. Since
   * you only need to implement 5 functions from FingerExercises.java, you can
   * expect to have failing tests for functions you haven't implemented. You can
   * comment out these extra tests or leave them alone.
   * 
   * You do not need to submit this file.
   */

  /*** GCD Tests ***/
  @Test
  public void TestGCDFortyAndTwelve() {
    int expected = 4;
    int actual = FingerExercises.gcd(40, 12);
    assertEquals("gcd of 12 and 40", expected, actual);
  }

  @Test
  public void TestGCDThreeAndSix() {
    int expected = 3;
    int actual = FingerExercises.gcd(3, 6);
    assertEquals("gcd of 3 and 6", expected, actual);
  }

  @Test
  public void TestGCDOneAndThree() {
    int expected = 1;
    int actual = FingerExercises.gcd(1, 3);
    assertEquals("gcd of 1 and 3", expected, actual);
  }

  /*** Sum Between Tests ***/
  @Test
  public void TestSumBetweenOneFive() {
    int expected = 15;
    int actual = FingerExercises.sumBetween(1, 5);
    assertEquals("sum between 1 and 5", expected, actual);
  }

  @Test
  public void TestSumBetweenTenTwelve() {
    int expected = 33;
    int actual = FingerExercises.sumBetween(10, 12);
    assertEquals("sum between 10 and 12", expected, actual);
  }

  @Test
  public void TestSumBetweenNegFiveFive() {
    int expected = 0;
    int actual = FingerExercises.sumBetween(-5, 5);
    assertEquals("sum between -5 and 5", expected, actual);
  }

  @Test
  public void TestSumBetweenFiveFive() {
    int expected = 5;
    int actual = FingerExercises.sumBetween(5, 5);
    assertEquals("sum between 5 and 5", expected, actual);
  }

  /*** Sum To Tests ***/
  @Test
  public void TestSumToFive() {
    int expected = 15;
    int actual = FingerExercises.sumTo(5);
    assertEquals("sum to 5", expected, actual);
  }

  @Test
  public void TestSumToTwelve() {
    int expected = 78;
    int actual = FingerExercises.sumTo(12);
    assertEquals("sum to 12", expected, actual);
  }

  @Test
  public void TestSumToOne() {
    int expected = 1;
    int actual = FingerExercises.sumTo(1);
    assertEquals("sum to 1", expected, actual);
  }

  /*** Find Second Largest Tests ***/
  @Test
  public void TestFindSecondLargestShortNoDuplicate() {
    int expected = 4;
    int actual = FingerExercises.findSecondLargest(new int[] { 10, 4, 1 });
    assertEquals("second largest of [10, 4, 1]", expected, actual);
  }

  @Test
  public void TestFindSecondLargestShortNoDuplicatePermuted() {
    int expected = 4;
    int actual = FingerExercises.findSecondLargest(new int[] { 4, 10, 1 });
    assertEquals("second largest of [4, 10, 1]", expected, actual);
  }

  @Test
  public void TestFindSecondLargestDuplicates() {
    int expected = 2;
    int actual = FingerExercises.findSecondLargest(new int[] { 2, 2, 1 });
    assertEquals("second largest of [2, 2, 1]", expected, actual);
  }

  @Test
  public void TestFindSecondLargestLongerOrdered() {
    int expected = 4;
    int actual = FingerExercises.findSecondLargest(new int[] { 1, 2, 3, 4, 5 });
    assertEquals("second largest of [1, 2, 3, 4, 5]", expected, actual);
  }

  @Test
  public void TestFindSecondLargestLongerScrambled() {
    int expected = 4;
    int actual = FingerExercises.findSecondLargest(new int[] { 5, 3, 4, 1, 2 });
    assertEquals("second largest of [5, 3, 4, 1, 2]", expected, actual);
  }

  /*** Sum of Digits Tests ***/
  @Test
  public void TestSumOfDigits74296() {
    int expected = 28;
    int actual = FingerExercises.sumOfDigits(74296);
    assertEquals("sum of digits 74296", expected, actual);
  }

  @Test
  public void TestSumOfDigitsZero() {
    int expected = 0;
    int actual = FingerExercises.sumOfDigits(0);
    assertEquals("sum of digits 0", expected, actual);
  }

  @Test
  public void TestSumOfDigits90000() {
    int expected = 9;
    int actual = FingerExercises.sumOfDigits(90000);
    assertEquals("sum of digits 90000", expected, actual);
  }

  @Test
  public void TestSumOfDigits1234() {
    int expected = 10;
    int actual = FingerExercises.sumOfDigits(1234);
    assertEquals("sum of digits 1234", expected, actual);
  }

  /*** Climb Stairs Tests ***/
  @Test
  public void TestClimbStairsZero() {
    int expected = 1;
    int actual = FingerExercises.countWaysToClimb(0);
    assertEquals("ways to climb 0 stairs", expected, actual);
  }

  @Test
  public void TestClimbStairsOne() {
    int expected = 1;
    int actual = FingerExercises.countWaysToClimb(1);
    assertEquals("ways to climb 1 stair", expected, actual);
  }

  @Test
  public void TestClimbStairsFour() {
    int expected = 5;
    int actual = FingerExercises.countWaysToClimb(4);
    assertEquals("ways to climb 4 stairs", expected, actual);
  }

  @Test
  public void TestClimbStairsFive() {
    int expected = 8;
    int actual = FingerExercises.countWaysToClimb(5);
    assertEquals("ways to climb 5 stairs", expected, actual);
  }

  /*** Log Tests ***/
  @Test
  public void TestLogBaseTenOfThousand() {
    int expected = 3;
    int actual = FingerExercises.log(10, 1000);
    assertEquals("log base 10 of 1000", expected, actual);
  }

  @Test
  public void TestLogBaseThreeOfOne() {
    int expected = 0;
    int actual = FingerExercises.log(3, 1);
    assertEquals("log base 3 of 1", expected, actual);
  }

  @Test
  public void TestLogBaseTwoOfThirtyThree() {
    int expected = 5;
    int actual = FingerExercises.log(2, 33);
    assertEquals("log base 2 of 33", expected, actual);
  }

  /*** Substring Tests ***/
  @Test
  public void TestSubstringAnBanana() {
    int expected = 2;
    int actual = FingerExercises.countSubstrings("an", "banana");
    assertEquals("count of an in banana", expected, actual);
  }

  @Test
  public void TestSubstringAnaBanana() {
    int expected = 2;
    int actual = FingerExercises.countSubstrings("ana", "banana");
    assertEquals("count of ana in banana", expected, actual);
  }

  @Test
  public void TestSubstringAnnaBanana() {
    int expected = 0;
    int actual = FingerExercises.countSubstrings("anna", "banana");
    assertEquals("count of anna in banana", expected, actual);
  }

  @Test
  public void TestSubstringPApple() {
    int expected = 2;
    int actual = FingerExercises.countSubstrings("p", "apple");
    assertEquals("count of p in apple", expected, actual);
  }

}
